﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Lastgang
{
    class Betriebsmittel
    {
        public virtual double BestimmeLeistung(double zeit)
        { return 0.0; }

        public virtual double MaximaleLast
        {
            get { return 0.0; }
        }
    }

    class Nachtleuchte : Betriebsmittel
    {
        double wattzahl;

        // Getter als Property
        public override double MaximaleLast
        {
            get { return wattzahl; }
        }

        public double GibMaximaleLast() // Getter
        {
            return wattzahl;
        }

        public void SetzeMaximaleLast(double wattzahl) // Setter
        {
            if(wattzahl < 0.0)
            { return; } // besser: Exception
            this.wattzahl = wattzahl;
        }

        public Nachtleuchte(double wattzahl)
        {
            this.wattzahl = wattzahl;
        }

        public override double BestimmeLeistung(double zeit) // zeit in Stunden, nur ein Tag
        {
            if(zeit < 6.0 || zeit > 20.0)
            {
                return wattzahl;
            }
            else
            {
                return 0.0;
            }
        }


        internal int blabla(double p1, int p2)
        {
            throw new NotImplementedException();
        }

        public int blubb { get; set; }
    }

    class Waschmaschine : Betriebsmittel
    {
        static Random zufall = new Random();
        double anfangszeit;

        public Waschmaschine()
        {
            anfangszeit = 14.0 + 6.0 * zufall.NextDouble();
        }

        // Getter als Property
        public override double MaximaleLast
        {
            get { return 2000.0; }
        }

        public override double BestimmeLeistung(double zeit)
        {
            if(zeit >= anfangszeit && zeit <= anfangszeit + 0.5)
            { return 2000.0; }
            else if (zeit > anfangszeit + 0.5 && zeit <= anfangszeit + 1.5)
            { return 500.0; }
            else
            { return 0.0; }
        }
    }

    struct Buch
    {
        public string titel;
        public string ISBN;
    }

}
