﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Lastgang
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        double rundenAuf125(double x)
        {
            if(x < 1e-10)
            {
                x = 1e-10;
                // throw new ApplicationException("zu kleiner Wert");
            }

            double größenordnung = Math.Pow(10.0, Math.Floor(Math.Log10(x)));
            double y = x / größenordnung;
            double z = 1.0;
            if(y > 5.0)
            { z = 10.0; }
            else if(y > 2.0)
            { z = 5.0; }
            else if(y > 1.0)
            { z = 2.0; }
            return z * größenordnung;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Betriebsmittel[] verbraucher = new Betriebsmittel[200];
            for (int i = 0; i < 100; i++)
            {
                verbraucher[i] = new Waschmaschine();
            }
            for (int i = 100; i < 200; i++)
            {
                verbraucher[i] = new Nachtleuchte(40.0);
            }

            double maxLast = 0.0;
            for (int i = 0; i < 200; i++)
            {
                maxLast += verbraucher[i].MaximaleLast;
            }

            double maxLastAufgerundet = rundenAuf125(maxLast);
            labelMaxY.Content = maxLastAufgerundet + " W";

            //double d = b.bestimmeLeistung(3.7);

            Polyline poly = new Polyline();

            for (int stunde = 0; stunde < 24; stunde++)
            {
                for (int minute = 0; minute < 60; minute++)
                {
                    double zeit = stunde + minute / 60.0;
                    double p = 0.0;
                    //w1.bestimmeLeistung(zeit);
                    //p += w2.bestimmeLeistung(zeit);
                    //p += w3.bestimmeLeistung(zeit);
                    //p += b.bestimmeLeistung(zeit);
                    for (int i = 0; i < 200; i++)
                    {
                        p += verbraucher[i].BestimmeLeistung(zeit);
                    }

                    double x = zeit / 24.0 * zeichenfläche.Width;
                    double y = (1.0 - p / maxLastAufgerundet) * zeichenfläche.Height;
                    Point punkt = new Point(x, y);
                    poly.Points.Add(punkt);
                }
            }

            poly.Stroke = Brushes.Red;
            poly.StrokeThickness = 2.0;
            zeichenfläche.Children.Clear();
            zeichenfläche.Children.Add(poly);
        }
    }
}
